# Elmo

🦊 Fantastic build system for your next app.

## Features

- Typescript-first approach
- Familiar API for next.js users
- Elmo's overhead to your project is 8KB (!)
- No babel, so builds are blazing fast
- 100% development/production parity
- Works on IE11+
- Compiles to a static website that you can put on netlify or cloudfront
- Server-side rendering outputs HTML files
- Built-in support for netlify's `_redirects` file
- SEO-ready for dynamic content using `_escaped_fragment_` 

## Goals

- I want a framework that brings back the simplicity of building websites 10 years ago with our modern day tools & techniques.
- I want a reliable website that don't go down and is cloud-agnostic.
- I want to be able to easily distribute my app globally so it loads fast for everyone around the world.
- I want a framework that is well-tested, small, performant and doesn't get in the way.

## Features

- [x] 100% static rendering
- [x] First class support for Preact
- [x] Code splitting
- [x] Asynchronous routing
- [x] Populating `<head>`
- [x] Add styled-jsx
- [x] Analyze command
  - [ ] Smarter ordering (biggest contributors first)
  - [ ] Parsed size (read from source file)
  - [ ] Gzipped size ("gzip-size" module)
- [x] Setup command
- [x] Watch server build during serve
- [x] _redirects route provider
- [x] Typescript loader support

- [ ] Testing
- [ ] Error page
- [ ] 404 page

## License

MIT
