"use strict";
//
// TODO: turn into a polyfill for:
//  https://developer.mozilla.org/en-US/docs/Web/API/URL/URL
exports.__esModule = true;
var qs_1 = require("./qs");
function parse(url) {
    var location = window.location;
    var a = document.createElement('a');
    a.href = url;
    // parse the query
    var q = a.search.slice(1);
    var query = q ? qs_1.parse(q) : {};
    return {
        protocol: !a.protocol || a.protocol === ':' ? location.protocol : a.protocol,
        host: a.host || location.host,
        port: a.port === '0' || a.port === ''
            ? port(a.protocol) || parseInt(location.port, 10)
            : parseInt(a.port, 10),
        hostname: a.hostname || location.hostname,
        hash: trimSlash(a.hash),
        search: trimSlash(a.search),
        query: query,
        pathname: trimSlash(a.pathname.charAt(0) !== '/' ? '/' + a.pathname : a.pathname),
        href: trimSlash(a.href)
    };
}
exports.parse = parse;
/**
 * Return default port for `protocol`.
 *
 * @param  {String} protocol
 * @return {String}
 * @api private
 */
function port(protocol) {
    switch (protocol) {
        case 'http:':
            return 80;
        case 'https:':
            return 443;
        default:
            return 0;
    }
}
/**
 * Clean path by stripping subsequent "//"'s. Without this
 * the user must be careful when to use "/" or not, which leads
 * to bad UX.
 */
function trimSlash(path) {
    return path === '/' ? path : path.replace(/\/+$/g, '');
}
