"use strict";
/*
 * Module dependencies
 */
exports.__esModule = true;
var tslib_1 = require("tslib");
var webpack_1 = require("../server/config/webpack");
var move = require("move-concurrently");
var path_1 = require("path");
var Webpack = require("webpack");
var tempy_1 = require("tempy");
var copy = require("cpy");
var del = require("del");
function Build(params) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _this = this;
        var env, root, tmpdir, outpath, s, b, stats;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    env = params.environment || 'production';
                    root = params.root || process.cwd();
                    tmpdir = tempy_1.directory();
                    outpath = path_1.resolve(root, params.outpath || 'build');
                    s = webpack_1["default"]({
                        environment: env,
                        target: 'server',
                        action: 'build',
                        outpath: tmpdir,
                        routes: [],
                        root: root
                    });
                    b = webpack_1["default"]({
                        environment: env,
                        target: 'browser',
                        action: 'build',
                        outpath: tmpdir,
                        routes: [],
                        root: root
                    });
                    return [4 /*yield*/, Promise.all([s, b].map(function (config) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                            var c, webpack;
                            return tslib_1.__generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, config];
                                    case 1:
                                        c = _a.sent();
                                        webpack = Webpack(c);
                                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                                webpack.run(function (err, stats) {
                                                    if (err)
                                                        return reject(err);
                                                    if (stats.hasErrors()) {
                                                        return reject(new Error(stats.toJson().errors.join('\n\n')));
                                                    }
                                                    return resolve(stats);
                                                });
                                            })];
                                }
                            });
                        }); }))
                        // copy the _redirects file over if there is any
                    ];
                case 1:
                    stats = _a.sent();
                    // copy the _redirects file over if there is any
                    return [4 /*yield*/, copy(path_1.join(root, '_redirects'), tmpdir)
                        // delete the existing outpath
                    ];
                case 2:
                    // copy the _redirects file over if there is any
                    _a.sent();
                    // delete the existing outpath
                    return [4 /*yield*/, del(outpath)
                        // move the files over
                    ];
                case 3:
                    // delete the existing outpath
                    _a.sent();
                    // move the files over
                    return [4 /*yield*/, move(tmpdir, outpath)];
                case 4:
                    // move the files over
                    _a.sent();
                    return [2 /*return*/, stats];
            }
        });
    });
}
exports["default"] = Build;
