"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var preact_1 = require("preact");
var router_1 = require("./router");
var Link = /** @class */ (function (_super) {
    tslib_1.__extends(Link, _super);
    function Link() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Link.prototype.onClick = function (_e, href) {
        router_1["default"].push(href);
    };
    Link.prototype.render = function (_a) {
        var _this = this;
        var href = _a.href, children = _a.children;
        if (!children || !children[0])
            return null;
        var firstChild = children[0];
        if (!href ||
            typeof firstChild === 'string' ||
            !firstChild.hasOwnProperty('nodeName')) {
            return preact_1.h("a", { href: href }, children);
        }
        return preact_1.cloneElement(firstChild, {
            onClick: function (e) { return _this.onClick(e, href); }
        });
    };
    return Link;
}(preact_1.Component));
exports["default"] = Link;
