"use strict";
exports.__esModule = true;
var pascal = require("to-pascal-case");
function createPage(pageName) {
    var className = pascal(pageName);
    return "import { h, Component } from 'preact'\nimport { Head } from 'elmo'\n\nexport default class " + className + " extends Component {\n  static defaultProps = {\n    greeting: 'hello'\n  }\n\n  static async getInitialProps () {\n    return {\n      greeting: 'hola'\n    }\n  }\n\n  constructor(props) {\n    super(props)\n    this.state = {}\n  }\n\n  render(props, state) {\n    return (\n      <div class='page'>\n        <Head>\n          <title>hello " + pageName + "!</title>\n        </Head>\n        {props.greeting} " + pageName + "!\n      </div>\n    )\n  }\n}\n";
}
exports.createPage = createPage;
function createTSPage(pageName) {
    var className = pascal(pageName);
    return "import { h, Component, ComponentProps } from 'preact'\nimport { Head } from 'elmo'\n\n// " + pageName + " props\ninterface Props extends ComponentProps {\n  greeting: string\n}\n\n// " + pageName + " state\ninterface State {\n}\n\nexport default class " + className + " extends Component<Props, State> {\n  static defaultProps: Props = {\n    greeting: 'hello'\n  }\n\n  static async getInitialProps(): Promise<Props> {\n    return {\n      greeting: 'hola'\n    }\n  }\n\n  constructor (props: Props) {\n    super(props)\n    this.state = {}\n  }\n\n  render (props: Props, _state: State) {\n    return (\n      <div class='page'>\n        <Head>\n          <title>{props.greeting} " + pageName + "!</title>\n        </Head>\n        {props.greeting} " + pageName + "!\n        <style scoped>{`\n          .page {\n            height: 100vh;\n            width: 100vw;\n            background: #fefefe;\n          }\n        `}</style>\n      </div>\n    )\n  }\n} \n";
}
exports.createTSPage = createTSPage;
