"use strict";
exports.__esModule = true;
var prev = {};
var tags = {};
exports["default"] = (typeof window === 'undefined' ? renderOnServer : renderOnClient);
function renderOnServer() { }
exports.renderOnServer = renderOnServer;
function renderOnClient(styles) {
    patch(diff(prev, styles));
    prev = styles;
}
exports.renderOnClient = renderOnClient;
function diff(a, b) {
    // added
    var added = {};
    for (var id in b) {
        if (!b.hasOwnProperty(id))
            continue;
        if (!a[id])
            added[id] = b[id];
    }
    // removed
    var removed = {};
    for (var id in a) {
        if (!a.hasOwnProperty(id))
            continue;
        if (!b[id])
            removed[id] = a[id];
    }
    return [added, removed];
}
var fromServer = {};
function patch(_a) {
    var added = _a[0], removed = _a[1];
    // add the new tags
    for (var id in added) {
        // Avoid duplicates from server-rendered markup
        if (!fromServer[id]) {
            fromServer[id] = document.getElementById(id);
        }
        tags[id] = fromServer[id] || makeStyleTag(added[id]);
    }
    // remove the old tags
    for (var id in removed) {
        var t = tags[id];
        delete tags[id];
        t.parentNode && t.parentNode.removeChild(t);
        // Avoid checking the DOM later on
        delete fromServer[id];
    }
}
function makeStyleTag(css) {
    var tag = document.createElement('style');
    tag.appendChild(document.createTextNode(css));
    var head = document.head || document.getElementsByTagName('head')[0];
    var firstStyle = document.getElementsByTagName('style')[0];
    head.insertBefore(tag, firstStyle);
    return tag;
}
