import * as ts from 'typescript';
export interface Result extends ts.TranspileOutput {
    styles: {}[];
}
export declare type Options = {
    importName?: string;
    importFrom?: string;
    runtime?: boolean;
};
export declare type Visitors<T> = {
    [type: number]: ((node: T, context?: ts.TransformationContext) => T | void) | {
        enter?: (node: T, context?: ts.TransformationContext) => T | void;
        exit?: (node: T, context?: ts.TransformationContext) => T | void;
    };
};
export default function Transform<T extends ts.Node>(opts?: Options): Visitors<T>;
export declare function updateClassRecursively(options: Options, node: ts.JsxElement | ts.JsxSelfClosingElement, hash: string): ts.JsxElement | ts.JsxSelfClosingElement | void;
export declare function updateClass(node: ts.JsxOpeningElement, hash: string): ts.JsxOpeningElement | void;
