"use strict";
var _this = this;
exports.__esModule = true;
var tslib_1 = require("tslib");
// import * as supertest from 'promisify-supertest'
var fs_1 = require("mz/fs");
var jsdom = require("jsdom-global");
// import { h, render } from 'preact'
var mkdir = require("make-dir");
var path_1 = require("path");
var del = require("del");
var taz_1 = require("taz");
// // Helpers
var tick = function () { return new Promise(function (res) { return setTimeout(res, 0); }); };
var evaluate_1 = require("./helpers/evaluate");
var contains_1 = require("./helpers/contains");
var files_1 = require("./helpers/files");
var equal_1 = require("./helpers/equal");
// elmo commands
var setup_1 = require("../src/commands/setup");
var build_1 = require("../src/commands/build");
// import Serve from '../src/commands/serve'
taz_1["default"]('full build test using setup', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var root, html, common, js, cleanup, page;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                root = path_1.join(__dirname, '..', 'tmp');
                return [4 /*yield*/, del(root)];
            case 1:
                _a.sent();
                return [4 /*yield*/, mkdir(root)];
            case 2:
                _a.sent();
                return [4 /*yield*/, setup_1["default"]({ root: root, typescript: true })
                    // maintain a consistent page in case the scaffolding changes
                ];
            case 3:
                _a.sent();
                // maintain a consistent page in case the scaffolding changes
                return [4 /*yield*/, files_1["default"](root, {
                        'pages/index/index.tsx': "\n    import { h, Component, ComponentProps } from 'preact'\n    import { Head } from 'elmo'\n    \n    // index props\n    interface Props extends ComponentProps {\n      greeting: string\n    }\n    \n    // index state\n    interface State {\n    }\n    \n    export default class Index extends Component<Props, State> {\n      static defaultProps: Props = {\n        greeting: 'hello'\n      }\n    \n      static async getInitialProps(): Promise<Props> {\n        return {\n          greeting: 'hola'\n        }\n      }\n    \n      constructor (props: Props) {\n        super(props)\n        this.state = {}\n      }\n    \n      render (props: Props, _state: State) {\n        return (\n          <div class='page'>\n            <Head>\n              <title>{props.greeting} index!</title>\n            </Head>\n            {props.greeting} index!\n            <style scoped>{`\n              .page {\n                height: 100vh;\n                width: 100vw;\n                background: #fefefe;\n              }\n            `}</style>\n          </div>\n        )\n      }\n    } \n    "
                    })];
            case 4:
                // maintain a consistent page in case the scaffolding changes
                _a.sent();
                return [4 /*yield*/, build_1["default"]({ root: root })];
            case 5:
                _a.sent();
                return [4 /*yield*/, contains_1["default"](root, [
                        'build/common.js',
                        'build/index.html',
                        'build/index.js',
                        'build/static/favicon.ico',
                        'build/_redirects',
                        'package.json',
                        'pages/index/index.tsx',
                        'pages/_document.tsx',
                        'static/favicon.ico',
                        'tsconfig.json',
                        '_redirects'
                    ])];
            case 6:
                _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'index.html'), 'utf8')];
            case 7:
                html = _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'common.js'), 'utf8')];
            case 8:
                common = _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'index.js'), 'utf8')];
            case 9:
                js = _a.sent();
                cleanup = jsdom(html, { url: 'http://localhost:5000/' });
                equal_1["default"](document.documentElement.outerHTML, "<html class=\"no-js\" lang=\"en\"><head><meta charset=\"utf-8\"><meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge,chrome=1\"><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\"><link rel=\"icon\" sizes=\"16x16 32x32\" href=\"/static/favicon.ico\"><link rel=\"shortcut icon\" href=\"/static/favicon.ico\"><meta name=\"twitter:image\" content=\"http://mat.tm/__CARD__\"><meta name=\"twitter:creator\" content=\"@mattmueller\"><meta name=\"twitter:site\" content=\"@mattmueller\"><meta name=\"twitter:card\" content=\"summary_large_image\"><meta property=\"og:image\" content=\"http://mat.tm/__CARD__\"><meta property=\"og:image:height\" content=\"550\"><meta property=\"og:image:width\" content=\"940\"><meta property=\"og:image:type\" content=\"image/png\"><meta property=\"og:description\" content=\"This is an incredible website powered by Elmo\"><meta property=\"og:url\" content=\"http://mat.tm\"><meta property=\"og:title\" content=\"Elmo Site\"><meta name=\"description\" content=\"This is an incredible website powered by Elmo\"><title class=\"preact-head\">hello index!</title><style id=\"tsx-y5p1no\">.page.tsx-y5p1no{height:100vh;width:100vw;background:#fefefe}</style></head><body><div id=\"elmo.page\"><div class=\"page tsx-y5p1no\">hello index!</div></div><div id=\"elmo.scripts\"><script type=\"text/javascript\">window.prerenderReady=false;</script><script type=\"text/javascript\" src=\"/common.js\"></script><script type=\"text/javascript\" src=\"/index.js\"></script></div></body></html>");
                return [4 /*yield*/, tick()];
            case 10:
                _a.sent();
                page = document.querySelector('.page');
                // this comes from the server
                equal_1["default"](document.title, 'hello index!');
                equal_1["default"](page && page.innerHTML, 'hello index!');
                // make sure common doesn't throw
                evaluate_1["default"]('common.js', common);
                evaluate_1["default"]('index.js', js);
                return [4 /*yield*/, tick()
                    // after hydrating
                ];
            case 11:
                _a.sent();
                // after hydrating
                equal_1["default"](window.prerenderReady, true);
                equal_1["default"](document.title, 'hola index!');
                equal_1["default"](page && page.innerHTML, 'hola index!');
                cleanup();
                return [4 /*yield*/, del(root)];
            case 12:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
taz_1["default"]('test a custom document', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var root, html, common, js, cleanup, page;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                root = path_1.join(__dirname, '..', 'tmp');
                return [4 /*yield*/, del(root)];
            case 1:
                _a.sent();
                return [4 /*yield*/, mkdir(root)];
            case 2:
                _a.sent();
                return [4 /*yield*/, setup_1["default"]({ root: root, typescript: true })];
            case 3:
                _a.sent();
                return [4 /*yield*/, files_1["default"](root, {
                        'pages/_document.tsx': "\n    import { Document } from 'elmo'\n    import { h } from 'preact'\n    const { Head, Page, Scripts } = Document\n    \n    export default class CustomDocument extends Document {\n      render() {\n        return (\n          <html>\n            <Head>\n              <link href=\"/static/css/normalize.css\" rel=\"stylesheet\" />\n              <link href=\"/static/css/layout.css\" rel=\"stylesheet\" />\n              <link href=\"/static/css/spacing.css\" rel=\"stylesheet\" />\n              <link href=\"/static/css/global.css\" rel=\"stylesheet\" />\n            </Head>\n            <body>\n              <div class=\"page-wrapper\">\n                <Page />\n              </div>\n              <div class=\"scripts-wrapper\">\n              <Scripts />\n              </div>\n            </body>\n          </html>\n        )\n      }\n    }\n    ",
                        'pages/index/index.tsx': "\n    import { h, Component, ComponentProps } from 'preact'\n    import { Head } from 'elmo'\n    \n    // index props\n    interface Props extends ComponentProps {\n      greeting: string\n    }\n    \n    // index state\n    interface State {\n    }\n    \n    export default class Index extends Component<Props, State> {\n      static defaultProps: Props = {\n        greeting: 'hello'\n      }\n    \n      static async getInitialProps(): Promise<Props> {\n        return {\n          greeting: 'hola'\n        }\n      }\n    \n      constructor (props: Props) {\n        super(props)\n        this.state = {}\n      }\n    \n      render (props: Props, _state: State) {\n        return (\n          <div class='page'>\n            <Head>\n              <title>{props.greeting} index!</title>\n            </Head>\n            {props.greeting} index!\n            <style scoped>{`\n              .page {\n                height: 100vh;\n                width: 100vw;\n                background: #fefefe;\n              }\n            `}</style>\n          </div>\n        )\n      }\n    } \n    "
                    })];
            case 4:
                _a.sent();
                return [4 /*yield*/, build_1["default"]({ root: root })];
            case 5:
                _a.sent();
                return [4 /*yield*/, contains_1["default"](root, [
                        'build/common.js',
                        'build/index.html',
                        'build/index.js',
                        'build/static/favicon.ico',
                        'build/_redirects',
                        'package.json',
                        'pages/_document.tsx',
                        'pages/index/index.tsx',
                        'static/favicon.ico',
                        'tsconfig.json',
                        '_redirects'
                    ])];
            case 6:
                _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'index.html'), 'utf8')];
            case 7:
                html = _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'common.js'), 'utf8')];
            case 8:
                common = _a.sent();
                return [4 /*yield*/, fs_1.readFile(path_1.join(root, 'build', 'index.js'), 'utf8')];
            case 9:
                js = _a.sent();
                cleanup = jsdom(html, { url: 'http://localhost:5000/' });
                equal_1["default"](document.documentElement.outerHTML, "<html><head><link href=\"/static/css/global.css\" rel=\"stylesheet\"><link href=\"/static/css/spacing.css\" rel=\"stylesheet\"><link href=\"/static/css/layout.css\" rel=\"stylesheet\"><link href=\"/static/css/normalize.css\" rel=\"stylesheet\"><title class=\"preact-head\">hello index!</title><style id=\"tsx-y5p1no\">.page.tsx-y5p1no{height:100vh;width:100vw;background:#fefefe}</style></head><body><div class=\"page-wrapper\"><div id=\"elmo.page\"><div class=\"page tsx-y5p1no\">hello index!</div></div></div><div class=\"scripts-wrapper\"><div id=\"elmo.scripts\"><script type=\"text/javascript\">window.prerenderReady=false;</script><script type=\"text/javascript\" src=\"/common.js\"></script><script type=\"text/javascript\" src=\"/index.js\"></script></div></div></body></html>");
                return [4 /*yield*/, tick()];
            case 10:
                _a.sent();
                page = document.querySelector('.page');
                // this comes from the server
                equal_1["default"](document.title, 'hello index!');
                equal_1["default"](page && page.innerHTML, 'hello index!');
                // make sure common doesn't throw
                evaluate_1["default"]('common.js', common);
                evaluate_1["default"]('index.js', js);
                return [4 /*yield*/, tick()
                    // after hydrating
                ];
            case 11:
                _a.sent();
                // after hydrating
                equal_1["default"](window.prerenderReady, true);
                equal_1["default"](document.title, 'hola index!');
                equal_1["default"](page && page.innerHTML, 'hola index!');
                cleanup();
                return [4 /*yield*/, del(root)];
            case 12:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
taz_1["default"]('missing tsconfig', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var root, e_1;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                root = path_1.join(__dirname, '..', 'tmp');
                return [4 /*yield*/, del(root)];
            case 1:
                _a.sent();
                return [4 /*yield*/, mkdir(root)];
            case 2:
                _a.sent();
                return [4 /*yield*/, setup_1["default"]({ root: root, typescript: true })];
            case 3:
                _a.sent();
                return [4 /*yield*/, del(path_1.join(root, 'tsconfig.json'))];
            case 4:
                _a.sent();
                _a.label = 5;
            case 5:
                _a.trys.push([5, 7, , 8]);
                return [4 /*yield*/, build_1["default"]({ root: root })];
            case 6:
                _a.sent();
                return [3 /*break*/, 8];
            case 7:
                e_1 = _a.sent();
                equal_1["default"](e_1.message.split('\n')[0], 'Module build failed: Error: invalid or missing tsconfig.json at: /Users/matt/Projects/elmo/tmp/tsconfig.json');
                return [3 /*break*/, 8];
            case 8: return [4 /*yield*/, del(root)];
            case 9:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
taz_1["default"]('test multiple pages', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
    return [2 /*return*/];
}); }); });
taz_1["default"]('test Router', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
    return [2 /*return*/];
}); }); });
taz_1["default"]('test <Link/>', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
    return [2 /*return*/];
}); }); });
