import { h, Component, ComponentProps } from 'preact'
import { Head } from 'elmo'

// index props
interface Props extends ComponentProps {
  greeting: string
}

// index state
interface State {
}

export default class Index extends Component<Props, State> {
  static defaultProps: Props = {
    greeting: 'hello'
  }

  static async getInitialProps(): Promise<Props> {
    return {
      greeting: 'hola'
    }
  }

  constructor(props: Props) {
    super(props)
    this.state = {}
  }

  render(props: Props, _state: State) {
    return (
      <div class='page'>
        <Head>
          <title>{props.greeting} index!</title>
        </Head>
        {props.greeting} index!
        <style scoped>{`
        .page {
          height: 100vh;
          width: 100vw;
          background: #fefefe;
        }
        `}</style>
      </div>
    )
  }
} 