import { h, Component, cloneElement, ComponentProps } from 'preact'
import Router from './router'

export interface Props extends ComponentProps {
  href: string
}

export default class Link extends Component<Props, {}> {
  onClick(_e: MouseEvent, href: string) {
    Router.push(href)
  }

  render({ href, children }: Props): JSX.Element | null {
    if (!children || !children[0]) return null
    const firstChild = children[0] as preact.VNode<any>

    if (
      !href ||
      typeof firstChild === 'string' ||
      !firstChild.hasOwnProperty('nodeName')
    ) {
      return <a href={href}>{children}</a>
    }

    return cloneElement(firstChild, {
      onClick: (e: MouseEvent) => this.onClick(e, href)
    })
  }
}
