import { Params } from '../../elmo'

export const development = (_params: Params) => {
  return {
    // sourceRoot: params.root,
    sourceMaps: true,
    presets: [
      [
        require.resolve('babel-preset-env'),
        {
          targets: {
            chrome: 56,
            node: 7
          }
          // modules: false
        }
      ]
    ],
    plugins: [
      require.resolve('babel-plugin-transform-class-properties'),
      require.resolve('styled-jsx/babel'),
      [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
    ]
  }
}

export const production = (_params: Params) => {
  return {
    // sourceRoot: params.root,
    sourceMaps: true,
    presets: [require.resolve('babel-preset-env')],
    plugins: [
      require.resolve('babel-plugin-transform-class-properties'),
      [
        require.resolve('babel-plugin-transform-runtime'),
        { polyfill: false, useBuiltIns: true, useESModules: true }
      ],
      require.resolve('styled-jsx/babel'),
      [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
    ]
  }
}

export const typescript = (_params: Params) => {
  return {
    sourceMaps: true,
    plugins: [
      require.resolve('styled-jsx/babel'),
      [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
    ]
  }
}
