import { h } from 'preact'

export default function flushToVNode(flushed: { [id: string]: string }) {
  const arr = []

  for (let id in flushed) {
    const css = flushed[id]
    arr.push(
      h('style', {
        key: id,
        id: id,
        dangerouslySetInnerHTML: {
          __html: css
        }
      })
    )
  }

  return arr.reverse()
}

export function flushToHTML(flushed: { [id: string]: string }) {
  const arr = []

  for (let id in flushed) {
    arr.push(`<style>${flushed[id]}</style>`)
  }

  return arr.reverse().join('')
}
